Subject: Re: [PATCH] powerpc: convert 'iommu_alloc failed' messages to dynamic debug

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 14 Jun 2016 07:26:56 +1000

On Mon, 2016-06-13 at 10:27 -0300, Mauricio Faria de Oliveira wrote:
> Hi Ben,
> 
> On 06/11/2016 08:02 PM, Benjamin Herrenschmidt wrote:
> > I'm not fan of this. This is a very useful message to diagnose why,
> > for example, your network adapter is not working properly.
> > 
> > A lot of drivers don't deal well with IOMMU errors.
> > 
> > The fact that NVME trigger these is a problem that needs to be
> > solved
> > differently.
> 
> Ok, I understand your points.
> 
> Thanks for the review -- helps in setting another direction.

I've been thinking about this a bit... it might be worthwhile adding
a dma_* call to query the approximate size of the IOMMU window, as
a way for the device to adjust its requirements dynamically.

Another option would be to use a dma_attr for silencing mapping errors
which NVME could use provided it does handle them gracefully ...

Cheers,
Ben.